/* Created and written by kipa00.
 * You can freely modify or distribute this code:
 * - without redistributing the modified code
 * - without removing this comment
 * A code judged AC by this code do not guarantee
 * that your code is absolutely correct.
 * USE AT YOUR OWN RISK.
 */

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.Random;
import java.util.Vector;

public class Main {
	public static final String[][] ansSet = new String[][] {
		new String[] {""},
		new String[] {"CareTreat"},
		new String[] {"Dangerous"},
		new String[] {"CareTreat, Dangerous", "Dangerous, CareTreat"},
		new String[] {"FoodType"},
		new String[] {"CareTreat, FoodType", "FoodType, CareTreat"},
		new String[] {"Dangerous, FoodType", "FoodType, Dangerous"},
		new String[] {
			"CareTreat, Dangerous, FoodType", "CareTreat, FoodType, Dangerous",
			"Dangerous, CareTreat, FoodType", "Dangerous, FoodType, CareTreat",
			"FoodType, CareTreat, Dangerous", "FoodType, Dangerous, CareTreat"
		}
	};

	public static void main(String[] args) throws Exception {
		Vector<Room> rooms = new Vector<Room>();
		int tc_num;
		boolean is_windows = System.getProperty("os.name").startsWith("Windows");
		if (args.length >= 2) {
			if (args[0].equalsIgnoreCase("make")) {
				int cnt = Integer.parseInt(args[1]);
				int i, j, k, c = 0, temp = 0;
				Random rand = new Random();
				for (i=1; i<=cnt; ++i) {
					rooms.clear();
					try {
						FileOutputStream fos = new FileOutputStream("tests/i" + i + ".bin");
						int numRooms = rand.nextInt(5000) + 1;
						fos.write(numRooms >> 8);
						fos.write(numRooms & 255);
						for (j=0; j<numRooms; ++j) {
							Room nowRoom = new Room();
							int numFood = rand.nextInt(100) + 1;
							int spval = rand.nextInt(3);
							fos.write(numFood);
							for (k=0; k<numFood; ++k) {
								boolean food = spval == 2 ? rand.nextInt(2) == 1 : spval == 1;
								nowRoom.addFood(food);
								temp = (temp << 1) | (food ? 1 : 0);
								++c;
								if (c == 8) {
									fos.write(temp);
									temp = c = 0;
								}
							}
							if (c > 0) {
								fos.write(temp << (8 - c));
								temp = c = 0;
							}
							int numAnimal = rand.nextInt(100) + 1;
							fos.write(numAnimal);
							String spstr = (new String[] {"C", "H", "O", "CH", "HO", "OC", "CHO"})[rand.nextInt(7)];
							String aglvl = (new String[] {"0", "1", "2", "01", "12", "20", "012"})[rand.nextInt(7)];
							for (k=0; k<numAnimal; ++k) {
								char type = spstr.charAt(rand.nextInt(spstr.length()));
								int agr_lvl = aglvl.charAt(rand.nextInt(aglvl.length())) - '0';
								nowRoom.addAnimal(new Animal(type, "", "", agr_lvl));
								temp = (temp << 4) | ("CHO".indexOf(type) << 2) | agr_lvl;
								c += 4;
								if (c == 8) {
									fos.write(temp);
									temp = c = 0;
								}
							}
							if (c > 0) {
								fos.write(temp << (8 - c));
								temp = c = 0;
							}
							rooms.add(nowRoom);
						}
						fos.write(makeAnswer(rooms));
						fos.close();
					} catch (Exception err) {
						System.err.println("An error occured while making test cases: " + err.getMessage());
						err.printStackTrace();
					}
				}
			} else if (args[0].equalsIgnoreCase("read")) {
				manual_check(args[1]);
			} else if (args[0].equalsIgnoreCase("zip")) {
				try {
					BufferedReader br = new BufferedReader(new FileReader(args[1]));
					int i, len = Integer.parseInt(br.readLine());
					if (args.length == 2) {
						throw new Exception("output file not specified");
					}
					FileOutputStream fos = new FileOutputStream(args[2]);
					if (len < 1 || 65535 < len) {
						throw new Exception("# of rooms must be between 1 and 65535 (inclusive)");
					} else {
						fos.write(len >> 8);
						fos.write(len & 255);
					}
					for (i=0; i<len; ++i) {
						Room nowRoom = new Room();
						String[] foodInfo = br.readLine().trim().split("\\s+");
						int j, k = 0, c = 0;
						if (foodInfo.length < 1 || 255 < foodInfo.length) {
							throw new Exception("# of foods in each room must be between 1 and 255 (inclusive)");
						}
						fos.write(foodInfo.length);
						for (j=0; j<foodInfo.length; ++j) {
							boolean food = foodInfo[j].equalsIgnoreCase("meat");
							nowRoom.addFood(food);
							k = (k << 1) | (food ? 1 : 0);
							++c;
							if (c == 8) {
								fos.write(k);
								k = c = 0;
							}
						}
						if (c > 0) {
							fos.write(k << (8 - c));
							k = c = 0;
						}
						int aniLen = Integer.parseInt(br.readLine());
						if (aniLen < 1 || 255 < aniLen) {
							throw new Exception("# of animals in each room must be between 1 and 255 (inclusive)");
						}
						fos.write(aniLen);
						for (j=0; j<aniLen; ++j) {
							String[] nai = br.readLine().trim().split("\\s+");
							int agr_lvl = Integer.parseInt(nai[3]);
							if (agr_lvl < 0 || 2 < agr_lvl) {
								throw new Exception("aggression level of each animal must be between 0 and 2 (inclusive)");
							}
							nowRoom.addAnimal(new Animal(nai[0].charAt(0), nai[1], nai[2], agr_lvl));
							k = (k << 4) | ("CHO".indexOf(nai[0].charAt(0)) << 2) | Integer.parseInt(nai[3]);
							c += 4;
							if (c == 8) {
								fos.write(k);
								k = c = 0;
							}
						}
						if (c > 0) {
							fos.write(k << (8 - c));
							k = c = 0;
						}
						rooms.add(nowRoom);
					}
					br.close();
					fos.write(makeAnswer(rooms));
					fos.close();
				} catch (Exception err) {
					System.err.println("An error occured while zipping the file: " + err.getMessage());
					err.printStackTrace();
				}
			}
		} else if (args.length == 1) {
			manual_check(args[0]);
		} else {
			for (tc_num = 1; new File("tests/i" + tc_num + ".bin").exists(); ++tc_num) {
				try {
					check("tests/i" + tc_num + ".bin");
				} catch (Exception err) {
					throw new Exception((is_windows ? "" : "\u001B[1;31m") + "Wrong answer on test " + tc_num + ", " + err.getMessage() + (is_windows ? "" : "\u001B[0m"));
				}
			}
			if (tc_num == 1) {
				throw new Exception((is_windows ? "" : "\u001B[1;31m") + "No test cases provided; could not test the code" + (is_windows ? "" : "\u001B[0m"));
			} else {
				System.out.println(is_windows ? "AC!" : "\u001B[1;32mAC!\u001B[0m (with " + (tc_num - 1) + " test case" + (tc_num == 2 ? ")" : "s)"));
			}
		}
	}

	public static void manual_check(String filename) {
		Vector<Room> rooms = new Vector<Room>();
		try {
			BufferedReader br = new BufferedReader(new FileReader(filename));
			int i, len = Integer.parseInt(br.readLine());
			for (i=0; i<len; ++i) {
				Room nowRoom = new Room();
				String[] foodInfo = br.readLine().trim().split("\\s+");
				int j;
				for (j=0; j<foodInfo.length; ++j) {
					nowRoom.addFood(foodInfo[j].equalsIgnoreCase("meat"));
				}
				int aniLen = Integer.parseInt(br.readLine());
				for (j=0; j<aniLen; ++j) {
					String[] nai = br.readLine().trim().split("\\s+");
					nowRoom.addAnimal(new Animal(nai[0].charAt(0), nai[1], nai[2], Integer.parseInt(nai[3])));
				}
				rooms.add(nowRoom);
			}
			br.close();
			Manage mn = new Manage(new ManageInfo(rooms));
			mn.report().printAll();
		} catch (FileNotFoundException err) {
			err.printStackTrace();
		} catch (IOException err) {
			System.err.println("Exception thrown while reading the input (probably malformed?) : ");
			err.printStackTrace();
		}
	}

	public static String getRandomString(int len) {
		StringBuilder sb = new StringBuilder();
		Random rand = new Random();
		while (len --> 0) {
			sb.append("0123456789QWERTYUIOP ASDFGHJKLZXCVBNMqwertyuiopasdfghjklzxcvbnm".charAt(rand.nextInt(63)));
		}
		return sb.toString();
	}

	public static void check(String filename) throws Exception {
		Vector<Room> rooms = new Vector<Room>();
		FileInputStream fis = new FileInputStream(filename);
		int i, numRooms = fis.read();
		numRooms = (numRooms << 8) | fis.read();
		Random rand = new Random();
		for (i=0; i<numRooms; ++i) {
			Room nowRoom = new Room();
			int k = 0, c = 0;
			for (int numFoods = fis.read(); numFoods --> 0; k <<= 1, --c) {
				if (c <= 0) {
					c = 8;
					k = fis.read();
				}
				nowRoom.addFood((k & 128) == 128);
			}
			k = c = 0;
			for (int numAnimals = fis.read(); numAnimals --> 0; k <<= 4, c -= 4) {
				if (c <= 0) {
					c = 8;
					k = fis.read();
				}
				String sp = getRandomString(rand.nextInt(5) + 10), name = getRandomString(rand.nextInt(5) + 10), cname = "Animal";
				int type = (k >>> 6) & 3, aglvl = (k >>> 4) & 3;
				char ctype = "CHO".charAt(type);
				Animal ani = null;
				if (rand.nextInt(2) == 0) {
					ani = new Animal("CHO".charAt(type), sp, name, aglvl);
				} else {
					cname = (new String[] {"Carnivore", "Herbivore", "Omnivore"})[type];
					if (type == 0) {
						ani = new Carnivore(ctype, sp, name, aglvl);
					} else if (type == 1) {
						ani = new Herbivore(ctype, sp, name, aglvl);
					} else if (type == 2) {
						ani = new Omnivore(ctype, sp, name, aglvl);
					}
					sp += (new String[] {"(Carni)", "(Herbi)", "(Omni)"})[type];
				}
				if (!sp.equals(ani.getSpeciesName())) {
					throw new Exception("room " + (i + 1) + ": " + cname + " getSpeciesName() error");
				} else if (!name.equals(ani.getName())) {
					throw new Exception("room " + (i + 1) + ": " + cname + " getName() error");
				}
				nowRoom.addAnimal(ani);
			}
			rooms.add(nowRoom);
		}
		Report rp = new Manage(new ManageInfo(rooms)).report();
		if (Integer.parseInt(rp.lines.get(0)) != numRooms) {
			throw new Exception("line 1: # of rooms mismatch");
		}
		for (i=1; i<=numRooms; ++i) {
			String rpl = null;
			try {
				rpl = rp.lines.get(i);
			} catch (Exception err) {
				throw new Exception("too few lines");
			}
			String[] form = rpl.trim().split("\\s+", 4);
			if (form.length != 3 && form.length != 4) {
				throw new Exception("line " + (i + 1) + ": output form mismatch");
			}
			if (!(form[0].equals("Room") && Integer.parseInt(form[1]) == i && form[2].equals(":"))) {
				throw new Exception("line " + (i + 1) + ": output form mismatch");
			}
			int ans = fis.read();
			if ((form.length == 3 && ans != 0) || (form.length == 4 && !Arrays.asList(ansSet[ans]).contains(form[3]))) {
				int n;
				try {
					n = whatLine(rpl);
				} catch (Exception err) {
					throw new Exception("line " + (i + 1) + ": output form mismatch");
				}
				try {
					throw new Exception("line " + (i + 1) + ": expected \"" + ansSet[ans][0] + "\", got \"" + form[3] + "\"");
				} catch (ArrayIndexOutOfBoundsException err) {
					throw new Exception("line " + (i + 1) + ": expected \"" + ansSet[ans][0] + "\", got \"\"");
				}
			}
		}
		fis.close();
	}

	public static int whatLine(String line) throws Exception {
		int i;
		String toFind = null;
		try {
			toFind = line.split(":")[1].trim();
		} catch (Exception err) {
			return 0;
		}
		for (i=0; i<8; ++i) {
			if (Arrays.asList(ansSet[i]).contains(toFind)) {
				return i;
			}
		}
		throw new Exception("invalid output");
	}

	public static byte[] makeAnswer(Vector<Room> rooms) throws Exception {
		int i, len = rooms.size();
		byte[] res = new byte[len];
		Report rp = new Manage(new ManageInfo(rooms)).report();
		for (i=1; i<=len; ++i) {
			res[i - 1] = (byte)whatLine(rp.lines.get(i));
		}
		return res;
	}
}
